﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;

public class Program
{
    public static void Main()
    {
        var source = Enumerable.Range(0, 1000);
        while (true)
        {
            Foo result = UnsafeParallel(source, n => {
                Thread.Sleep(0);
                return new Foo { A = n, B = n, C = n, D = n, E = n };
            });

            if (result.A != result.B || result.A != result.C || result.A != result.D || result.A != result.E)
            {
                Console.WriteLine("Tearing detected!");
                Console.WriteLine(result.A);
                Console.WriteLine(result.B);
                Console.WriteLine(result.C);
                Console.WriteLine(result.D);
                Console.WriteLine(result.E);
                break;
            }
        }
    }

    static T UnsafeParallel<T>(IEnumerable<int> source, Func<int, T> action)
    {
        T result = default(T);
        Parallel.ForEach(source, (i, state) => {
            result = action(i);
            state.Stop();
        });

        return result;
    }


    static T SafeParallel<T>(IEnumerable<int> source, Func<int, T> action)
    {
        object result = default(T);
        Parallel.ForEach(source, (i, state) => {
            result = action(i);
            state.Stop();
        });

        return (T)result;
    }
}

public struct Foo
{
    public int A { get; set; }
    public int B { get; set; }
    public int C { get; set; }
    public int D { get; set; }
    public int E { get; set; }
}